/*
** Compiler compatibility macros
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
*/

#ifndef INCLUDED_COMPILER_H
#define INCLUDED_COMPILER_H

#ifdef __SASC
#define SAVEDS __saveds
#define ASM __asm
#define REG(x,y) register __ ## x y
#define ALIGNED __aligned
#endif

#ifdef __GNUC__
#define SAVEDS
#define ASM
#define ALIGNED
#ifdef __MORPHOS__
#define REG(x,y) y
#else
#define REG(x,y) y __asm( #x )
#endif
#endif

#ifdef __MORPHOS__
#define InitHook(hook, funcname, data) ((hook)->h_Entry = (void *)&Gate_##funcname, (hook)->h_Data = (APTR)(data))
#else
#define InitHook(hook, funcname, data) ((hook)->h_Entry = (HOOKFUNC)funcname, (hook)->h_Data = (APTR)(data))
#endif


#endif	/* INCLUDED_COMPILER_H */
